Index: pplinux/linuxnew/net/bridge/br.c
diff -u pplinux/linuxnew/net/bridge/br.c:1.1.323.1 pplinux/linuxnew/net/bridge/br.c:1.2
--- pplinux/linuxnew/net/bridge/br.c:1.1.323.1	Thu Feb  3 10:01:00 2005
+++ pplinux/linuxnew/net/bridge/br.c	Wed Apr  6 11:53:13 2005
@@ -22,6 +22,7 @@
 #include <linux/init.h>
 #include <linux/if_bridge.h>
 #include <linux/brlock.h>
+#include <linux/rtnetlink.h>
 #include <asm/uaccess.h>
 #include "br_private.h"
 
@@ -54,15 +55,13 @@
 	return 0;
 }
 
-static void __br_clear_ioctl_hook(void)
-{
-	br_ioctl_hook = NULL;
-}
-
 static void __exit br_deinit(void)
 {
 	unregister_netdevice_notifier(&br_device_notifier);
-	br_call_ioctl_atomic(__br_clear_ioctl_hook);
+
+	rtnl_lock();
+	br_ioctl_hook = NULL;
+	rtnl_unlock();
 
 	br_write_lock_bh(BR_NETPROTO_LOCK);
 	br_handle_frame_hook = NULL;
Index: pplinux/linuxnew/net/bridge/br_if.c
diff -u pplinux/linuxnew/net/bridge/br_if.c:1.1.323.1 pplinux/linuxnew/net/bridge/br_if.c:1.2
--- pplinux/linuxnew/net/bridge/br_if.c:1.1.323.1	Thu Feb  3 10:01:00 2005
+++ pplinux/linuxnew/net/bridge/br_if.c	Wed Apr  6 11:53:13 2005
@@ -19,11 +19,10 @@
 #include <linux/inetdevice.h>
 #include <linux/rtnetlink.h>
 #include <linux/brlock.h>
+#include <linux/etherdevice.h>
 #include <asm/uaccess.h>
 #include "br_private.h"
 
-static struct net_bridge *bridge_list;
-
 static int br_initial_port_cost(struct net_device *dev)
 {
 	if (!strncmp(dev->name, "lec", 3))
@@ -44,7 +43,7 @@
 	struct net_bridge_port *p;
 	struct net_bridge_port **pptr;
 
-	if ((p = dev->br_port) == NULL)
+	if ((p = dev->br_port) == NULL || p->br != br)
 		return -EINVAL;
 
 	br_stp_disable_port(p);
@@ -69,22 +68,6 @@
 	return 0;
 }
 
-static struct net_bridge **__find_br(char *name)
-{
-	struct net_bridge **b;
-	struct net_bridge *br;
-
-	b = &bridge_list;
-	while ((br = *b) != NULL) {
-		if (!strncmp(br->dev.name, name, IFNAMSIZ))
-			return b;
-
-		b = &(br->next);
-	}
-
-	return NULL;
-}
-
 static void del_ifs(struct net_bridge *br)
 {
 	br_write_lock_bh(BR_NETPROTO_LOCK);
@@ -177,42 +160,48 @@
 int br_add_bridge(char *name)
 {
 	struct net_bridge *br;
+	struct net_device *dev;
+	int err;
 
 	if ((br = new_nb(name)) == NULL)
 		return -ENOMEM;
 
-	if (__dev_get_by_name(name) != NULL) {
-		kfree(br);
-		return -EEXIST;
+	dev = &br->dev;
+	if (strchr(dev->name, '%')) {
+		err = dev_alloc_name(dev, dev->name);
+		if (err < 0)
+			goto  out;
 	}
 
-	br->next = bridge_list;
-	bridge_list = br;
+	err = register_netdevice(dev);
+	if (err == 0)
+		br_inc_use_count();
 
-	br_inc_use_count();
-	register_netdev(&br->dev);
-
-	return 0;
+ out:
+	return err;
 }
 
 int br_del_bridge(char *name)
 {
-	struct net_bridge **b;
+	struct net_device *dev;
 	struct net_bridge *br;
 
-	if ((b = __find_br(name)) == NULL)
+	dev = __dev_get_by_name(name);
+	if (!dev)
 		return -ENXIO;
 
-	br = *b;
+	if (dev->hard_start_xmit != br_dev_xmit)
+		return -EPERM;
 
-	if (br->dev.flags & IFF_UP)
+	if (dev->flags & IFF_UP)
 		return -EBUSY;
 
-	del_ifs(br);
+	br = dev->priv;
+	BUG_ON(&br->dev != dev);
 
-	*b = br->next;
+	del_ifs(br);
 
-	unregister_netdev(&br->dev);
+	unregister_netdevice(dev);
 	kfree(br);
 	br_dec_use_count();
 
@@ -232,6 +221,9 @@
 	if (dev->hard_start_xmit == br_dev_xmit)
 		return -ELOOP;
 
+	if (!is_valid_ether_addr(dev->dev_addr))
+		return -EADDRNOTAVAIL;
+
 	dev_hold(dev);
 	write_lock_bh(&br->lock);
 	if ((p = new_nbp(br, dev)) == NULL) {
@@ -267,16 +259,12 @@
 
 int br_get_bridge_ifindices(int *indices, int num)
 {
-	struct net_bridge *br;
-	int i;
-
-	br = bridge_list;
-	for (i=0;i<num;i++) {
-		if (br == NULL)
-			break;
+	struct net_device *dev;
+	int i = 0;
 
-		indices[i] = br->dev.ifindex;
-		br = br->next;
+	for (dev = dev_base; i < num && dev != NULL; dev = dev->next) {
+		if (dev->hard_start_xmit == br_dev_xmit)
+			indices[i++] = dev->ifindex;
 	}
 
 	return i;
Index: pplinux/linuxnew/net/bridge/br_ioctl.c
diff -u pplinux/linuxnew/net/bridge/br_ioctl.c:1.1.323.1 pplinux/linuxnew/net/bridge/br_ioctl.c:1.2
--- pplinux/linuxnew/net/bridge/br_ioctl.c:1.1.323.1	Thu Feb  3 10:01:00 2005
+++ pplinux/linuxnew/net/bridge/br_ioctl.c	Wed Apr  6 11:53:13 2005
@@ -16,6 +16,7 @@
 #include <linux/kernel.h>
 #include <linux/if_bridge.h>
 #include <linux/inetdevice.h>
+#include <linux/rtnetlink.h>
 #include <asm/uaccess.h>
 #include "br_private.h"
 
@@ -230,12 +231,10 @@
 	return -EOPNOTSUPP;
 }
 
-static DECLARE_MUTEX(ioctl_mutex);
-
 int br_ioctl_deviceless_stub(unsigned long arg)
 {
-	int err;
 	unsigned long i[3];
+	int err;
 
 	if (!capable(CAP_NET_ADMIN))
 		return -EPERM;
@@ -243,32 +242,17 @@
 	if (copy_from_user(i, (void *)arg, 3*sizeof(unsigned long)))
 		return -EFAULT;
 
-	down(&ioctl_mutex);
-	err = br_ioctl_deviceless(i[0], i[1], i[2]);
-	up(&ioctl_mutex);
-
+	rtnl_lock();
+	err =  br_ioctl_deviceless(i[0], i[1], i[2]);
+	rtnl_unlock();
 	return err;
 }
 
 int br_ioctl(struct net_bridge *br, unsigned int cmd, unsigned long arg0, unsigned long arg1, unsigned long arg2)
 {
-	int err;
-
 	if (!capable(CAP_NET_ADMIN))
 		return -EPERM;
 
-	down(&ioctl_mutex);
-	err = br_ioctl_deviceless(cmd, arg0, arg1);
-	if (err == -EOPNOTSUPP)
-		err = br_ioctl_device(br, cmd, arg0, arg1, arg2);
-	up(&ioctl_mutex);
-
-	return err;
-}
-
-void br_call_ioctl_atomic(void (*fn)(void))
-{
-	down(&ioctl_mutex);
-	fn();
-	up(&ioctl_mutex);
+	ASSERT_RTNL();
+	return br_ioctl_device(br, cmd, arg0, arg1, arg2);
 }
Index: pplinux/linuxnew/net/bridge/br_private.h
diff -u pplinux/linuxnew/net/bridge/br_private.h:1.1.323.1 pplinux/linuxnew/net/bridge/br_private.h:1.2
--- pplinux/linuxnew/net/bridge/br_private.h:1.1.323.1	Thu Feb  3 10:01:00 2005
+++ pplinux/linuxnew/net/bridge/br_private.h	Wed Apr  6 11:53:13 2005
@@ -79,7 +79,6 @@
 
 struct net_bridge
 {
-	struct net_bridge		*next;
 	rwlock_t			lock;
 	struct net_bridge_port		*port_list;
 	struct net_device		dev;
@@ -169,7 +168,6 @@
 extern void br_handle_frame(struct sk_buff *skb);
 
 /* br_ioctl.c */
-extern void br_call_ioctl_atomic(void (*fn)(void));
 extern int br_ioctl(struct net_bridge *br,
 	     unsigned int cmd,
 	     unsigned long arg0,
Index: pplinux/linuxnew/net/bridge/br_stp.c
diff -u pplinux/linuxnew/net/bridge/br_stp.c:1.1.323.1 pplinux/linuxnew/net/bridge/br_stp.c:1.2
--- pplinux/linuxnew/net/bridge/br_stp.c:1.1.323.1	Thu Feb  3 10:01:00 2005
+++ pplinux/linuxnew/net/bridge/br_stp.c	Wed Apr  6 11:53:13 2005
@@ -20,7 +20,10 @@
 #include "br_private.h"
 #include "br_private_stp.h"
 
-
+/* since time values in bpdu are in jiffies and then scaled (1/256)
+ * before sending, make sure that is at least one.
+ */
+#define MESSAGE_AGE_INCR	((HZ < 256) ? 1 : (HZ/256))
 
 /* called under ioctl_lock or bridge lock */
 int br_is_root_bridge(struct net_bridge *br)
@@ -160,24 +163,26 @@
 	bpdu.root_path_cost = br->root_path_cost;
 	bpdu.bridge_id = br->bridge_id;
 	bpdu.port_id = p->port_id;
-	bpdu.message_age = 0;
-	if (!br_is_root_bridge(br)) {
+	if (br_is_root_bridge(br)) 
+		bpdu.message_age = 0;
+	else {
 		struct net_bridge_port *root;
-		unsigned long age;
 
 		root = br_get_port(br, br->root_port);
-		age = br_timer_get_residue(&root->message_age_timer) + 1;
-		bpdu.message_age = age;
+		bpdu.message_age =  br_timer_get_residue(&root->message_age_timer)
+			+ MESSAGE_AGE_INCR;
 	}
 	bpdu.max_age = br->max_age;
 	bpdu.hello_time = br->hello_time;
 	bpdu.forward_delay = br->forward_delay;
 
-	br_send_config_bpdu(p, &bpdu);
+	if (bpdu.message_age < br->max_age) {
+		br_send_config_bpdu(p, &bpdu);
 
-	p->topology_change_ack = 0;
-	p->config_pending = 0;
-	br_timer_set(&p->hold_timer, jiffies);
+		p->topology_change_ack = 0;
+		p->config_pending = 0;
+		br_timer_set(&p->hold_timer, jiffies);
+	}
 }
 
 /* called under bridge lock */
Index: pplinux/linuxnew/net/core/pktgen.c
diff -u pplinux/linuxnew/net/core/pktgen.c:1.1.323.1 pplinux/linuxnew/net/core/pktgen.c:1.2
--- pplinux/linuxnew/net/core/pktgen.c:1.1.323.1	Tue Feb 22 09:49:30 2005
+++ pplinux/linuxnew/net/core/pktgen.c	Wed Feb 23 18:03:37 2005
@@ -1,5 +1,5 @@
 /* -*-linux-c-*-
- * $Id: pktgen.c,v 1.1 2005/02/21 17:28:41 jim Exp $
+ * $Id: pktgen.c,v 1.8 2002/07/15 19:30:17 robert Exp $
  * pktgen.c: Packet Generator for performance evaluation.
  *
  * Copyright 2001, 2002 by Robert Olsson <robert.olsson@its.uu.se>
Index: pplinux/linuxnew/net/core/skbuff.c
diff -u pplinux/linuxnew/net/core/skbuff.c:1.1.323.1 pplinux/linuxnew/net/core/skbuff.c:1.2
--- pplinux/linuxnew/net/core/skbuff.c:1.1.323.1	Tue Feb 22 09:49:30 2005
+++ pplinux/linuxnew/net/core/skbuff.c	Wed Feb 23 18:03:37 2005
@@ -4,7 +4,7 @@
  *	Authors:	Alan Cox <iiitac@pyr.swan.ac.uk>
  *			Florian La Roche <rzsfl@rz.uni-sb.de>
  *
- *	Version:	$Id: skbuff.c,v 1.1 2005/02/21 17:28:41 jim Exp $
+ *	Version:	$Id: skbuff.c,v 1.90 2001/11/07 05:56:19 davem Exp $
  *
  *	Fixes:	
  *		Alan Cox	:	Fixed the worst of the load balancer bugs.
Index: pplinux/linuxnew/net/core/sock.c
diff -u pplinux/linuxnew/net/core/sock.c:1.1.323.1 pplinux/linuxnew/net/core/sock.c:1.2
--- pplinux/linuxnew/net/core/sock.c:1.1.323.1	Tue Feb 22 09:49:30 2005
+++ pplinux/linuxnew/net/core/sock.c	Wed Feb 23 18:03:37 2005
@@ -7,7 +7,7 @@
  *		handler for protocols to use and generic option handler.
  *
  *
- * Version:	$Id: sock.c,v 1.1 2005/02/21 17:28:41 jim Exp $
+ * Version:	$Id: sock.c,v 1.116 2001/11/08 04:20:06 davem Exp $
  *
  * Authors:	Ross Biro, <bir7@leland.Stanford.Edu>
  *		Fred N. van Kempen, <waltje@uWalt.NL.Mugnet.ORG>
Index: pplinux/linuxnew/net/ipv4/arp.c
diff -u pplinux/linuxnew/net/ipv4/arp.c:1.1.323.1 pplinux/linuxnew/net/ipv4/arp.c:1.2
--- pplinux/linuxnew/net/ipv4/arp.c:1.1.323.1	Thu Feb  3 10:00:59 2005
+++ pplinux/linuxnew/net/ipv4/arp.c	Wed Apr  6 11:53:13 2005
@@ -669,6 +669,7 @@
 	      unsigned char *dest_hw, unsigned char *src_hw,
 	      unsigned char *target_hw)
 {
+	struct in_device *in_dev = in_dev_get(dev);
 	struct sk_buff *skb;
 
 	/*
@@ -678,7 +679,8 @@
 	if (dev->flags&IFF_NOARP)
 		return;
 
-	skb = arp_create(type, ptype, dest_ip, dev, src_ip,
+	skb = arp_create(type, ptype, dest_ip, dev,
+			 (htonl(IN_DEV_PP_ARP_PROXY_SRC_IP(in_dev)) == src_ip && IN_DEV_PP_ARP_ZERO_SRC_IP(in_dev)) ? 0 : src_ip,
 			 dest_hw, src_hw, target_hw);
 	if (skb == NULL) {
 		return;
@@ -846,11 +848,38 @@
 
 	/* Special case: IPv4 duplicate address detection packet (RFC2131) */
 	if (sip == 0) {
-		if (arp->ar_op == htons(ARPOP_REQUEST) &&
-		    inet_addr_type(tip) == RTN_LOCAL &&
-		    !arp_ignore(in_dev,dev,sip,tip))
+	    /*
+	     * rwa: code modified to allow ARP requests with src ip == 0.0.0.0
+	     *      If the requested MAC is in the cache then we return it. Otherwise
+	     *	    forward the request with a valid source ip (set via /proc).
+	     */
+	    if (arp->ar_op == htons(ARPOP_REQUEST)) {
+		if (inet_addr_type(tip) == RTN_LOCAL) {
+		    if (!arp_ignore(in_dev,dev,sip,tip)) {
 			arp_send(ARPOP_REPLY,ETH_P_ARP,tip,dev,tip,sha,dev->dev_addr,dev->dev_addr);
-		goto out;
+		    }
+		} else if (IN_DEV_PP_ARP_PROXY_ENABLE(in_dev)) {
+		    n = __neigh_lookup(&arp_tbl, &tip, dev, 1);
+		    if (n) {
+			sip = htonl(IN_DEV_PP_ARP_PROXY_SRC_IP(in_dev));
+			if (n->nud_state & NUD_VALID) {
+			    char haddr[6];
+			    if (dev->addr_len <= sizeof(haddr)) {
+				read_lock_bh(&n->lock);
+				if (dev->addr_len) {
+				    memcpy(haddr, n->ha, dev->addr_len);
+				    read_unlock_bh(&n->lock);
+				    arp_send(ARPOP_REPLY,ETH_P_ARP,sip,dev,tip,sha,haddr,haddr);
+				}
+			    }
+			    neigh_release(n);
+			} else {
+			    arp_send(ARPOP_REQUEST,ETH_P_ARP,tip,dev,sip,tha,dev->dev_addr,NULL);
+			}
+		    }
+		}
+	    }
+	    goto out;
 	}
 
 	if (arp->ar_op == htons(ARPOP_REQUEST) &&
Index: pplinux/linuxnew/net/ipv4/devinet.c
diff -u pplinux/linuxnew/net/ipv4/devinet.c:1.1.323.1 pplinux/linuxnew/net/ipv4/devinet.c:1.2
--- pplinux/linuxnew/net/ipv4/devinet.c:1.1.323.1	Thu Feb  3 10:00:59 2005
+++ pplinux/linuxnew/net/ipv4/devinet.c	Wed Apr  6 11:53:13 2005
@@ -280,11 +280,15 @@
 				inet_free_ifa(ifa);
 				return -EEXIST;
 			}
+#if 0 /* kimble + devel firmware triggers this check */
 			if (ifa1->ifa_scope != ifa->ifa_scope) {
 				inet_free_ifa(ifa);
 				return -EINVAL;
 			}
-			ifa->ifa_flags |= IFA_F_SECONDARY;
+#else
+			if (ifa1->ifa_scope == ifa->ifa_scope)
+#endif
+				ifa->ifa_flags |= IFA_F_SECONDARY;
 		}
 	}
 
@@ -371,7 +375,9 @@
 	__in_dev_put(in_dev);
 
 	for (ifap=&in_dev->ifa_list; (ifa=*ifap)!=NULL; ifap=&ifa->ifa_next) {
-		if ((rta[IFA_LOCAL-1] && memcmp(RTA_DATA(rta[IFA_LOCAL-1]), &ifa->ifa_local, 4)) ||
+		/* rwa: added the scope check vor kimble */
+		if (ifm->ifa_scope != ifa->ifa_scope ||
+		    (rta[IFA_LOCAL-1] && memcmp(RTA_DATA(rta[IFA_LOCAL-1]), &ifa->ifa_local, 4)) ||
 		    (rta[IFA_LABEL-1] && strcmp(RTA_DATA(rta[IFA_LABEL-1]), ifa->ifa_label)) ||
 		    (rta[IFA_ADDRESS-1] &&
 		     (ifm->ifa_prefixlen != ifa->ifa_prefixlen ||
@@ -1135,7 +1141,7 @@
 static struct devinet_sysctl_table
 {
 	struct ctl_table_header *sysctl_header;
-	ctl_table devinet_vars[20];
+	ctl_table devinet_vars[23];
 	ctl_table devinet_dev[2];
 	ctl_table devinet_conf_dir[2];
 	ctl_table devinet_proto_dir[2];
@@ -1193,6 +1199,15 @@
 	{NET_IPV4_CONF_FORCE_IGMP_VERSION, "force_igmp_version",
 	 &ipv4_devconf.force_igmp_version, sizeof(int), 0644, NULL,
 	 &proc_dointvec},
+	{NET_IPV4_CONF_PP_ARP_ZERO_SRC_IP, "pp_arp_zero_src_ip",
+	 &ipv4_devconf.pp_arp_zero_src_ip, sizeof(int), 0644, NULL,
+	 &proc_dointvec},
+	{NET_IPV4_CONF_PP_ARP_PROXY_ENABLE, "pp_arp_proxy_enable",
+	 &ipv4_devconf.pp_arp_proxy_enable, sizeof(int), 0644, NULL,
+	 &proc_dointvec},
+	{NET_IPV4_CONF_PP_ARP_PROXY_SRC_IP, "pp_arp_proxy_src_ip",
+	 &ipv4_devconf.pp_arp_proxy_src_ip, sizeof(int), 0644, NULL,
+	 &proc_dointvec},
 	 {0}},
 
 	{{NET_PROTO_CONF_ALL, "all", NULL, 0, 0555, devinet_sysctl.devinet_vars},{0}},
Index: pplinux/linuxnew/net/ipv4/route.c
diff -u pplinux/linuxnew/net/ipv4/route.c:1.1.323.1 pplinux/linuxnew/net/ipv4/route.c:1.2
--- pplinux/linuxnew/net/ipv4/route.c:1.1.323.1	Thu Feb  3 10:00:59 2005
+++ pplinux/linuxnew/net/ipv4/route.c	Wed Apr  6 11:53:13 2005
@@ -1315,7 +1315,12 @@
 	if (in_dev == NULL)
 		return -EINVAL;
 
+#ifdef CONFIG_PEPPERCON
+	/* rwa: we receive multicast packets with 127.1.x.x as source */
+	if (MULTICAST(saddr) || BADCLASS(saddr) ||
+#else
 	if (MULTICAST(saddr) || BADCLASS(saddr) || LOOPBACK(saddr) ||
+#endif
 	    skb->protocol != htons(ETH_P_IP))
 		goto e_inval;
 
@@ -1429,7 +1434,12 @@
 	   by fib_lookup.
 	 */
 
+#ifdef CONFIG_PEPPERCON
+	/* rwa: we send packets with 127.1.x.x as source on ethX */
+	if (MULTICAST(saddr) || BADCLASS(saddr))
+#else
 	if (MULTICAST(saddr) || BADCLASS(saddr) || LOOPBACK(saddr))
+#endif
 		goto martian_source;
 
 	if (daddr == 0xFFFFFFFF || (saddr == 0 && daddr == 0))
Index: pplinux/linuxnew/net/ipv4/ipvs/ip_vs_conn.c
diff -u pplinux/linuxnew/net/ipv4/ipvs/ip_vs_conn.c:1.1.323.1 pplinux/linuxnew/net/ipv4/ipvs/ip_vs_conn.c:1.2
--- pplinux/linuxnew/net/ipv4/ipvs/ip_vs_conn.c:1.1.323.1	Thu Feb  3 10:00:59 2005
+++ pplinux/linuxnew/net/ipv4/ipvs/ip_vs_conn.c	Wed Apr  6 11:53:13 2005
@@ -980,7 +980,7 @@
 	/* update checksum because skb might be defragmented */
 	ip_send_check(iph);
 
-	if (unlikely(skb_headroom(skb) < rt->u.dst.dev->hard_header_len)) {
+	if (unlikely(skb_headroom(skb) < ((rt->u.dst.dev->hard_header_len + 15) & ~15))) {
 		if (skb_cow(skb, rt->u.dst.dev->hard_header_len)) {
 			ip_rt_put(rt);
 			IP_VS_ERR_RL("ip_vs_dr_xmit(): no memory\n");
Index: pplinux/linuxnew/net/ipv4/ipvs/ip_vs_core.c
diff -u pplinux/linuxnew/net/ipv4/ipvs/ip_vs_core.c:1.1.323.1 pplinux/linuxnew/net/ipv4/ipvs/ip_vs_core.c:1.2
--- pplinux/linuxnew/net/ipv4/ipvs/ip_vs_core.c:1.1.323.1	Thu Feb  3 10:00:59 2005
+++ pplinux/linuxnew/net/ipv4/ipvs/ip_vs_core.c	Wed Apr  6 11:53:13 2005
@@ -1035,8 +1035,15 @@
 	/*
 	 *	Big tappo: only PACKET_HOST (nor loopback neither mcasts)
 	 *	... don't know why 1st test DOES NOT include 2nd (?)
+	 *	rwa: ignore packets with loopback source addresses and packets
+	 *	     with (nfmark & 0x80000000)=1 (LVS-routed already).
 	 */
+#ifdef CONFIG_PEPPERCON
+	if (skb->pkt_type != PACKET_HOST || skb->dev == &loopback_dev
+	    || (skb->nfmark & 0x80000000) || LOOPBACK(iph->saddr)) {
+#else
 	if (skb->pkt_type != PACKET_HOST || skb->dev == &loopback_dev) {
+#endif
 		IP_VS_DBG(12, "packet type=%d proto=%d daddr=%d.%d.%d.%d ignored\n",
 			  skb->pkt_type,
 			  iph->protocol,
@@ -1131,7 +1138,7 @@
 	/* increase its packet counter and check if it is needed
 	   to be synchronized */
 	atomic_inc(&cp->in_pkts);
-	if (ip_vs_sync_state == IP_VS_STATE_MASTER &&
+	if (ip_vs_sync_state & IP_VS_STATE_MASTER &&
 	    (cp->protocol != IPPROTO_TCP ||
 	     cp->state == IP_VS_S_ESTABLISHED) &&
 	    (atomic_read(&cp->in_pkts) % 50 == sysctl_ip_vs_sync_threshold))
Index: pplinux/linuxnew/net/ipv4/ipvs/ip_vs_ctl.c
diff -u pplinux/linuxnew/net/ipv4/ipvs/ip_vs_ctl.c:1.1.323.1 pplinux/linuxnew/net/ipv4/ipvs/ip_vs_ctl.c:1.2
--- pplinux/linuxnew/net/ipv4/ipvs/ip_vs_ctl.c:1.1.323.1	Thu Feb  3 10:00:59 2005
+++ pplinux/linuxnew/net/ipv4/ipvs/ip_vs_ctl.c	Wed Apr  6 11:53:13 2005
@@ -1727,10 +1727,11 @@
 		ret = ip_vs_set_timeouts(urule);
 		goto out_unlock;
 	} else if (cmd == IP_VS_SO_SET_STARTDAEMON) {
-		ret = start_sync_thread(urule->state, urule->mcast_ifn);
+		ret = start_sync_thread(urule->state, urule->mcast_ifn,
+					urule->buildnr, urule->syncid);
 		goto out_unlock;
 	} else if (cmd == IP_VS_SO_SET_STOPDAEMON) {
-		ret = stop_sync_thread();
+		ret = stop_sync_thread(urule->state);
 		goto out_unlock;
 	} else if (cmd == IP_VS_SO_SET_ZERO) {
 		/* if no service address is set, zero counters in all */
@@ -2078,7 +2079,10 @@
 			goto out;
 		}
 		u.state = ip_vs_sync_state;
-		strcpy(u.mcast_ifn, ip_vs_mcast_ifn);
+		if (ip_vs_sync_state & IP_VS_STATE_MASTER)
+			strcpy(u.mcast_master_ifn, ip_vs_mcast_master_ifn);
+		if (ip_vs_sync_state & IP_VS_STATE_BACKUP)
+			strcpy(u.mcast_backup_ifn, ip_vs_mcast_backup_ifn);
 		if (copy_to_user(user, &u, sizeof(u)) != 0)
 			ret = -EFAULT;
 	}
Index: pplinux/linuxnew/net/ipv4/ipvs/ip_vs_sync.c
diff -u pplinux/linuxnew/net/ipv4/ipvs/ip_vs_sync.c:1.1.323.1 pplinux/linuxnew/net/ipv4/ipvs/ip_vs_sync.c:1.2
--- pplinux/linuxnew/net/ipv4/ipvs/ip_vs_sync.c:1.1.323.1	Thu Feb  3 10:01:00 2005
+++ pplinux/linuxnew/net/ipv4/ipvs/ip_vs_sync.c	Wed Apr  6 11:53:13 2005
@@ -11,11 +11,18 @@
  *
  * ip_vs_sync:  sync connection info from master load balancer to backups
  *              through multicast
+ *
+ * Changes:
+ *	Alexandre Cassen	:	Added master & backup support at a time.
+ *	Alexandre Cassen	:	Added SyncID support for incoming sync
+ *					messages filtering.
  */
 
+#define __KERNEL_SYSCALLS__            /*  for waitpid */
+
 #include <linux/module.h>
 #include <linux/slab.h>
-#include <linux/net.h>
+#include <linux/unistd.h>
 
 #include <linux/skbuff.h>
 #include <linux/in.h>
@@ -28,7 +35,7 @@
 #include <net/ip_vs.h>
 
 #define IP_VS_SYNC_GROUP 0xe0000051    /* multicast addr - 224.0.0.81 */
-#define IP_VS_SYNC_PORT  8848          /* multicast port */
+#define IP_VS_SYNC_PORT  2210 /*8848*/ /* multicast port */
 
 
 /*
@@ -66,29 +73,40 @@
 
 /*
   The master mulitcasts messages to the backup load balancers in the
-  following format.
+  following format. (changed by rwa)
 
        0                   1                   2                   3
        0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
-      |  Count Conns  |   Reserved    |            Size               |
+      |  Count Conns  |    Sync ID    |            Size               |
+      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+      |                          Build Number                         |
+      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+      +                         Sync ID (high)                        |
+      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+      +                         Sync ID (low)                         |
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
-      |                                                               |
       |                    IPVS Sync Connection (1)                   |
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
       |                            .                                  |
       |                            .                                  |
       |                            .                                  |
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
-      |                                                               |
       |                    IPVS Sync Connection (n)                   |
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+
+  Count Conns : Number of IPVS sync Connection entries.
+  Sync ID     : IPVS sync group we belong to.
+  Size        : Size of packet.
+
 */
-#define SYNC_MESG_MAX_SIZE      (24*50+4)
+#define SYNC_MESG_MAX_SIZE      (24*50+16)
 struct ip_vs_sync_mesg {
 	__u8                    nr_conns;
 	__u8                    reserved;
 	__u16                   size;
+	__u32			buildnr;
+	__u64			syncid;
 
 	/* ip_vs_sync_conn entries start here */
 };
@@ -113,6 +131,21 @@
 static struct ip_vs_sync_buff   *curr_sb = NULL;
 static spinlock_t curr_sb_lock = SPIN_LOCK_UNLOCKED;
 
+/* build number */
+static u32 ip_vs_buildnr = 0;
+
+/* ipvs sync daemon state */
+volatile int ip_vs_sync_state = IP_VS_STATE_NONE;
+volatile u64 ip_vs_master_syncid = 0;
+volatile u64 ip_vs_backup_syncid = 0;
+
+/* multicast interface name */
+char ip_vs_mcast_master_ifn[IP_VS_IFNAME_MAXLEN];
+char ip_vs_mcast_backup_ifn[IP_VS_IFNAME_MAXLEN];
+
+/* multicast addr */
+static struct sockaddr_in mcast_addr;
+
 static inline void sb_queue_tail(struct ip_vs_sync_buff *sb)
 {
 	spin_lock(&ip_vs_sync_lock);
@@ -150,8 +183,10 @@
 		return NULL;
 	}
 	sb->mesg->nr_conns = 0;
-	sb->mesg->size = 4;
-	sb->head = (unsigned char *)sb->mesg + 4;
+	sb->mesg->buildnr = ip_vs_buildnr;
+	sb->mesg->syncid = ip_vs_master_syncid;
+	sb->mesg->size = 8;
+	sb->head = (unsigned char *)sb->mesg + 8;
 	sb->end = (unsigned char *)sb->mesg + SYNC_MESG_MAX_SIZE;
 	sb->firstuse = jiffies;
 	return sb;
@@ -259,6 +294,20 @@
 		return;
 	}
 
+	/* SyncID sanity check */
+	if (ip_vs_backup_syncid != 0 && m->syncid != ip_vs_backup_syncid) {
+		IP_VS_DBG(7, "Ignoring incoming msg with syncid = 0x%llx\n",
+			  m->syncid);
+		return;
+	}
+
+	/* build number check */
+	if (m->buildnr != ip_vs_buildnr) {
+		IP_VS_DBG(7, "Ignoring incoming msg with buildnr = %u\n",
+			  m->buildnr);
+		return;
+	}
+
 	p = (char *)buffer + sizeof(struct ip_vs_sync_mesg);
 	for (i=0; i<m->nr_conns; i++) {
 		s = (struct ip_vs_sync_conn *)p;
@@ -302,16 +351,6 @@
 }
 
 
-/* ipvs sync daemon state */
-volatile int ip_vs_sync_state = IP_VS_STATE_NONE;
-
-/* multicast interface name */
-char ip_vs_mcast_ifn[IP_VS_IFNAME_MAXLEN];
-
-/* multicast addr */
-static struct sockaddr_in mcast_addr;
-
-
 /*
  *      Setup loopback of outgoing multicasts on a sending socket
  */
@@ -423,7 +462,7 @@
 		return NULL;
 	}
 
-	if (set_mcast_if(sock->sk, ip_vs_mcast_ifn) < 0) {
+	if (set_mcast_if(sock->sk, ip_vs_mcast_master_ifn) < 0) {
 		IP_VS_ERR("Error setting outbound mcast interface\n");
 		goto error;
 	}
@@ -431,7 +470,7 @@
 	set_mcast_loop(sock->sk, 0);
 	set_mcast_ttl(sock->sk, 1);
 
-	if (bind_mcastif_addr(sock, ip_vs_mcast_ifn) < 0) {
+	if (bind_mcastif_addr(sock, ip_vs_mcast_master_ifn) < 0) {
 		IP_VS_ERR("Error binding address of the mcast interface\n");
 		goto error;
 	}
@@ -477,7 +516,7 @@
 	/* join the multicast group */
 	if (join_mcast_group(sock->sk,
 			     (struct in_addr*)&mcast_addr.sin_addr,
-			     ip_vs_mcast_ifn) < 0) {
+			     ip_vs_mcast_backup_ifn) < 0) {
 		IP_VS_ERR("Error joining to the multicast group\n");
 		goto error;
 	}
@@ -550,12 +589,15 @@
 	return len;
 }
 
+static int errno;
 
 static DECLARE_WAIT_QUEUE_HEAD(sync_wait);
-static pid_t sync_pid = 0;
+static pid_t sync_master_pid = 0;
+static pid_t sync_backup_pid = 0;
 
 static DECLARE_WAIT_QUEUE_HEAD(stop_sync_wait);
-static int stop_sync = 0;
+static int stop_master_sync = 0;
+static int stop_backup_sync = 0;
 
 static void sync_master_loop(void)
 {
@@ -568,6 +610,10 @@
 	if (!sock)
 		return;
 
+	IP_VS_INFO("sync thread started: state = MASTER, mcast_ifn = %s, "
+		   "syncid = 0x%llx\n",
+		   ip_vs_mcast_master_ifn, ip_vs_master_syncid);
+
 	for (;;) {
 		while ((sb=sb_dequeue())) {
 			m = sb->mesg;
@@ -586,7 +632,7 @@
 			ip_vs_sync_buff_release(sb);
 		}
 
-		if (stop_sync)
+		if (stop_master_sync)
 			break;
 
 		__set_current_state(TASK_INTERRUPTIBLE);
@@ -625,6 +671,10 @@
 	if (!sock)
 		goto out;
 
+	IP_VS_INFO("sync thread started: state = BACKUP, mcast_ifn = %s, "
+		   "syncid = 0x%llx\n",
+		   ip_vs_mcast_backup_ifn, ip_vs_backup_syncid);
+
 	for (;;) {
 		/* do you have data now? */
 		while (!skb_queue_empty(&(sock->sk->receive_queue))) {
@@ -640,7 +690,7 @@
 			local_bh_enable();
 		}
 
-		if (stop_sync)
+		if (stop_backup_sync)
 			break;
 
 		__set_current_state(TASK_INTERRUPTIBLE);
@@ -655,12 +705,31 @@
 	kfree(buf);
 }
 
+static void sync_pid_set(int sync_state, pid_t sync_pid)
+{
+	if (sync_state == IP_VS_STATE_MASTER)
+		sync_master_pid = sync_pid;
+	else if (sync_state == IP_VS_STATE_BACKUP)
+		sync_backup_pid = sync_pid;
+}
+
+static void sync_stop_set(int sync_state, int set)
+{
+	if (sync_state == IP_VS_STATE_MASTER)
+		stop_master_sync = set;
+	else if (sync_state == IP_VS_STATE_BACKUP)
+		stop_backup_sync = set;
+	else {
+		stop_master_sync = set;
+		stop_backup_sync = set;
+	}
+}
 
 static int sync_thread(void *startup)
 {
 	DECLARE_WAITQUEUE(wait, current);
 	mm_segment_t oldmm;
-	int state;
+	int state = IP_VS_STATE_NONE;
 
 	MOD_INC_USE_COUNT;
 	daemonize();
@@ -668,12 +737,15 @@
 	oldmm = get_fs();
 	set_fs(KERNEL_DS);
 
-	if (ip_vs_sync_state == IP_VS_STATE_MASTER)
+	if (ip_vs_sync_state & IP_VS_STATE_MASTER && !sync_master_pid) {
+		state = IP_VS_STATE_MASTER;
 		sprintf(current->comm, "ipvs_syncmaster");
-	else if (ip_vs_sync_state == IP_VS_STATE_BACKUP)
+	} else if (ip_vs_sync_state & IP_VS_STATE_BACKUP && !sync_backup_pid) {
+		state = IP_VS_STATE_BACKUP;
 		sprintf(current->comm, "ipvs_syncbackup");
-	else IP_VS_BUG();
+	} else IP_VS_BUG();
 
+	/* Block all signals */
 	spin_lock_irq(&current->sigmask_lock);
 	siginitsetinv(&current->blocked, 0);
 	recalc_sigpending(current);
@@ -686,9 +758,7 @@
 
 	add_wait_queue(&sync_wait, &wait);
 
-	state = ip_vs_sync_state;
-	sync_pid = current->pid;
-	IP_VS_INFO("sync thread started.\n");
+	sync_pid_set(state, current->pid);
 	complete((struct completion *)startup);
 
 	/* processing master/backup loop here */
@@ -701,13 +771,13 @@
 	remove_wait_queue(&sync_wait, &wait);
 
 	/* thread exits */
-	sync_pid = 0;
+	sync_pid_set(state, 0);
 	IP_VS_INFO("sync thread stopped!\n");
 
 	set_fs(oldmm);
 	MOD_DEC_USE_COUNT;
 
-	stop_sync = 0;
+	sync_stop_set(state, 0);
 	wake_up(&stop_sync_wait);
 
 	return 0;
@@ -733,20 +803,29 @@
 }
 
 
-int start_sync_thread(int state, char *mcast_ifn)
+int start_sync_thread(int state, char *mcast_ifn, __u32 buildnr, __u64 syncid)
 {
 	DECLARE_COMPLETION(startup);
+	int waitpid_result;
 	pid_t pid;
 
-	if (sync_pid)
+	if ((state == IP_VS_STATE_MASTER && sync_master_pid) ||
+	    (state == IP_VS_STATE_BACKUP && sync_backup_pid))
 		return -EEXIST;
 
 	IP_VS_DBG(7, "%s: pid %d\n", __FUNCTION__, current->pid);
 	IP_VS_DBG(7, "Each ip_vs_sync_conn entry need %d bytes\n",
 		  sizeof(struct ip_vs_sync_conn));
 
-	ip_vs_sync_state = state;
-	strcpy(ip_vs_mcast_ifn, mcast_ifn);
+	ip_vs_buildnr = buildnr;
+	ip_vs_sync_state |= state;
+	if (state == IP_VS_STATE_MASTER) {
+		strcpy(ip_vs_mcast_master_ifn, mcast_ifn);
+		ip_vs_master_syncid = syncid;
+	} else {
+		strcpy(ip_vs_mcast_backup_ifn, mcast_ifn);
+		ip_vs_backup_syncid = syncid;
+	}
 
   repeat:
 	if ((pid = kernel_thread(fork_sync_thread, &startup, 0)) < 0) {
@@ -757,26 +836,37 @@
 		goto repeat;
 	}
 
+	/*
+	 * We must reap the fork_sync_thread here. Really needed to not
+	 * produce zombies while returning.
+	 */
+	if ((waitpid_result = waitpid(pid, NULL, __WCLONE)) != pid) {
+		IP_VS_ERR("%s: waitpid(%d,...) failed, errno %d\n",
+			  __FUNCTION__, pid, -waitpid_result);
+	}
+
 	wait_for_completion(&startup);
 
 	return 0;
 }
 
 
-int stop_sync_thread(void)
+int stop_sync_thread(int state)
 {
 	DECLARE_WAITQUEUE(wait, current);
 
-	if (!sync_pid)
+	if ((state == IP_VS_STATE_MASTER && !sync_master_pid) ||
+	    (state == IP_VS_STATE_BACKUP && !sync_backup_pid))
 		return -ESRCH;
 
 	IP_VS_DBG(7, "%s: pid %d\n", __FUNCTION__, current->pid);
-	IP_VS_INFO("stopping sync thread %d ...\n", sync_pid);
+	IP_VS_INFO("stopping sync thread %d ...\n",
+		   (state == IP_VS_STATE_MASTER) ? sync_master_pid : sync_backup_pid);
 
 	__set_current_state(TASK_UNINTERRUPTIBLE);
 	add_wait_queue(&stop_sync_wait, &wait);
-	ip_vs_sync_state = IP_VS_STATE_NONE;
-	stop_sync = 1;
+	sync_stop_set(state, 1);
+	ip_vs_sync_state -= state;
 	wake_up(&sync_wait);
 	schedule();
 	__set_current_state(TASK_RUNNING);
@@ -785,7 +875,8 @@
 	/* Note: no need to reap the sync thread, because its parent
 	   process is the init process */
 
-	if (stop_sync)
+	if ((state == IP_VS_STATE_MASTER && stop_master_sync) ||
+	    (state == IP_VS_STATE_BACKUP && stop_backup_sync))
 		IP_VS_BUG();
 
 	return 0;
Index: pplinux/linuxnew/net/ipv4/netfilter/Config.in
diff -u pplinux/linuxnew/net/ipv4/netfilter/Config.in:1.1.323.1 pplinux/linuxnew/net/ipv4/netfilter/Config.in:1.2
--- pplinux/linuxnew/net/ipv4/netfilter/Config.in:1.1.323.1	Thu Feb  3 10:00:59 2005
+++ pplinux/linuxnew/net/ipv4/netfilter/Config.in	Thu Feb  3 11:35:39 2005
@@ -53,6 +53,11 @@
     fi
   fi
 
+  dep_tristate '  Fast NAT' CONFIG_IP_NF_FASTNAT $CONFIG_IP_NF_IPTABLES 
+  if [ "$CONFIG_IP_NF_FASTNAT" != "n" ]; then
+    dep_tristate '    FASTNAT target support' CONFIG_IP_NF_TARGET_FASTNAT $CONFIG_IP_NF_FASTNAT
+  fi
+
   if [ "$CONFIG_IP_NF_CONNTRACK" != "n" ]; then
     dep_tristate '  Full NAT' CONFIG_IP_NF_NAT $CONFIG_IP_NF_IPTABLES $CONFIG_IP_NF_CONNTRACK
     if [ "$CONFIG_IP_NF_NAT" != "n" ]; then
Index: pplinux/linuxnew/net/ipv4/netfilter/Makefile
diff -u pplinux/linuxnew/net/ipv4/netfilter/Makefile:1.1.323.1 pplinux/linuxnew/net/ipv4/netfilter/Makefile:1.2
--- pplinux/linuxnew/net/ipv4/netfilter/Makefile:1.1.323.1	Thu Feb  3 10:00:59 2005
+++ pplinux/linuxnew/net/ipv4/netfilter/Makefile	Thu Feb  3 11:35:39 2005
@@ -61,6 +61,7 @@
 obj-$(CONFIG_IP_NF_FILTER) += iptable_filter.o
 obj-$(CONFIG_IP_NF_MANGLE) += iptable_mangle.o
 obj-$(CONFIG_IP_NF_NAT) += iptable_nat.o
+obj-$(CONFIG_IP_NF_FASTNAT) += iptable_fastnat.o
 
 # matches
 obj-$(CONFIG_IP_NF_MATCH_HELPER) += ipt_helper.o
@@ -100,6 +101,7 @@
 obj-$(CONFIG_IP_NF_TARGET_LOG) += ipt_LOG.o
 obj-$(CONFIG_IP_NF_TARGET_ULOG) += ipt_ULOG.o
 obj-$(CONFIG_IP_NF_TARGET_TCPMSS) += ipt_TCPMSS.o
+obj-$(CONFIG_IP_NF_TARGET_FASTNAT) += ipt_FASTNAT.o
 
 # generic ARP tables
 obj-$(CONFIG_IP_NF_ARPTABLES) += arp_tables.o
